﻿//  QR-Code  Magic - v3.1
//  by Stanislav Hoffman
//  основная идея - трассировка qr-кода по картинке.
//  доп. функции:  автоопределение размера по одному из трех больших квадратов, авто-поворот, авто-квадратичность (если растянут)
//  все операции происходят в новом файле
//  ЕСЛИ ВЫ В СТАРОМ AI   -   ПЕРЕД ЗАПУСКОМ ОТКЛЮЧИТЬ ПРИВЯЗКУ  К  "PIXEL GRID"

var doc = app.activeDocument;
var sel = doc.selection;
var mmp = 2.8346457481;

//  CHECK IF DOC == CMYK

//  check if doc has 1 object then paste qr-coe to new doc if its not
//  qr-code has to be rotated by one of 3 squares to top left, script will rotate it automatically and then back to original
//  if recognized qr matrix < 21 (min qr code matrix), then it seems be rotated wrong side.
//  major improvement - one side overscaled fix - makes both sides squared if it wasnt in original image
//  line 630 - mydark.gray = 100;

var matrix_from_corner;  //  объявим глобальную переменную для переменной внутри функции

var rotation_key = 0 ;

var check_key = 0 ;  //  ключ для проверки найденного квадрата, если 1 - покажет alert с выделением





//  СДЕЛТАЬ ПРОВЕРКУ НА ОДИН ОБЪЕКТ - ЕСЛИ НЕТ, КОПИРУЕМ В QR-КОД НОВЫЙ ФАЙЛ, ЕСЛИ ДА - ОСТАЁМСЯ

//alert ( "page items length   " + doc.pageItems.length ) ;
//alert ( "sel length   " + sel.length ) ;

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      GLOBAL START POINT

var start = 0 ; //  start key

if ( doc.pageItems.length == 1 )  //  проверка - в одкументе должен быть один объект - растр с qr-кодом, если нет, создаём новый документ и вставляем его туда
{
    start = 1 ; //  start key
}

//  проверить есть ли в выделении растр = qr-код

    if ( doc.pageItems.length > 1 && sel.length != 0 )  //  если в документе есть ещё объекты и есть хотя бы одно выделение (подразумеватся что это qr-код) - вставляем в новый документ
    {
        var newdoc = documents.add();

        // duplicate selection into new document
        sel [0].duplicate ( newdoc, ElementPlacement.PLACEATBEGINNING );
        redraw();
        
        var doc = app.activeDocument; //  update active document

        start = 1 ; //  start key

        executeMenuCommand("deselectall"); // update pasted objects otherwise it fails - unknown bug?
        redraw();
        
        traverseSceneObjects ( doc.pageItems );  //  release all objects from clips and groups
        redraw();

        delete_not_img() ; //  delete all not images - leave linked and embedded files
        redraw();
        
            if ( doc.pageItems.length > 1 )
            {
            alert ("repeat") ;
            delete_not_img() ; //  delete all not images - leave linked and embedded files
            redraw();
            }
        
    }

if ( doc.pageItems.length > 1 && sel.length == 0 ) { alert ( "select qr-code" ) ; }



if ( start == 1 ) //  start script
{

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

step_1 ();   //  начальный большой кусок кода



var rotsn = 0;  //  считаем число поворотов

//  проверим расчёт размера по квадрату - если маленький, значит квдрата слева сверху нет + проверка на квадратность из кода в строках 380 ( "15 12 22  проверим квадратность" )
if ( matrix_from_corner < 19  ||  rotation_key == 1 )  //  19 beacuse 21 x 21 is miminal qr-code size, so 19 chosen like 21 minus some space
{ 
    //alert ( "rotation key    " + rotation_key ) ; 
    //alert ("rotating to get things right...")

    executeMenuCommand("selectall");    var sel = doc.selection;

    sel[0].remove();

    redraw ();

    executeMenuCommand("unlockAll");

    executeMenuCommand("selectall");    var sel = doc.selection;

    sel[0].rotate(90) ;

    redraw ();

    step_1 ();  //  start all over again

    rotsn ++ ;  //  считаем число поворотов, чтобы потом вернуть обратно

}

//alert ( rotsn ) ;








function step_1 () 
{

var doc = app.activeDocument;  
executeMenuCommand("selectall");
var sel = doc.selection;

sel[0].duplicate ( doc.activeLayer, ElementPlacement.PLACEATBEGINNING );

sel[0].locked = true;

doc.selection = null;

executeMenuCommand("selectall");
var sel = doc.selection;  //  update selection

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    RASTERIZE 400 dpi
  var rasterizeOptions = new RasterizeOptions;  
  rasterizeOptions.antiAliasingMethod = AntiAliasingMethod.ARTOPTIMIZED;  
  rasterizeOptions.backgroundBlack = false;  
  rasterizeOptions.clippingMask = false;  
  rasterizeOptions.colorModel = RasterizationColorModel.GRAYSCALE;  // GRAYSCALE
  rasterizeOptions.convertSpotColors = false;   
  rasterizeOptions.convertTextToOutlines = false;  
  rasterizeOptions.includeLayers = false;  
  rasterizeOptions.padding = 0;  
  rasterizeOptions.resolution = 600;  //  на 400 dpi пропадали 1-2 квадратика на плохом коде
  rasterizeOptions.transparency = true;  
  doc.rasterize(sel[0], sel[0].controlBounds, rasterizeOptions);
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

executeMenuCommand("selectall");
var sel = doc.selection;  //  update selection

//  trace every selected ratser item with user preset
    var Tracing_Preset = 'Black and White Logo';  

    for ( var m=0; m < sel.length ; m++ )  
    {  
        //if (sel[m].typename == 'RasterItem')
        //{
            //alert ("yes");
            var pic = sel[m].trace();  
            pic.tracing.tracingOptions.loadFromPreset(Tracing_Preset);   
            pic.tracing.expandTracing().selected = true;   //  expand   traced
        //}  
    }

//  GET BW VALUES FROM TRACE

executeMenuCommand('ungroup');
executeMenuCommand('ungroup');
executeMenuCommand('ungroup');
executeMenuCommand('ungroup');
executeMenuCommand('ungroup');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   удаляем белые объекты
executeMenuCommand("selectall");    var sel = doc.selection;  //  update selection

for ( i = 0; i < sel.length; i++ ) 
{
    if (sel[i].filled == true && sel[i].fillColor.typename == "GrayColor")
    {
        //alert (sel[i].fillColor.gray);

        if ( sel[i].fillColor.gray == 0 )  //  find white objects to remove
        { 
        doc.selection = null;
        //alert ("123");
        sel[i].selected = true;
        i = sel.length;  //  stop  cycles
        executeMenuCommand('Find Fill Color menu item');
        }
    }
}

executeMenuCommand('clear');  //  remove white objects

executeMenuCommand("selectall");
executeMenuCommand('group');

var sel = doc.selection;  //  update selection

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   DEFAULT THE ROTATION
var x = 0;
var w1 = sel[0].width;
var w2 = 0;  //  w2 на старте всегда  меньше w1

for (i = 0; i < 40; i++)
{
if ( w2 < w1 )   {  w1 = sel[0].width;  x = x - 0.2;  sel[0].rotate(x);  w2 = sel[0].width;  redraw();  }    else { sel[0].rotate(-x); break }
}
/////////////////////////////////////////   CHANGE DIRECTION
w1 = sel[0].width;
w2 = 0;
x = 0;

for (i = 0; i < 40; i++)  //  w2 на старте всегда  меньше w1
{
if ( w2 < w1 )    {  w1 = sel[0].width;  x = x + 0.2;  sel[0].rotate(x);  w2 = sel[0].width;  redraw();  }   else { sel[0].rotate(-x); break }
}


/////////////////////////////////////////   FINE-TUNE ROTATION
for (i = 0; i < 40; i++)
{
if ( w2 < w1 )   {  w1 = sel[0].width;  x = 0.2;  sel[0].rotate(x);  w2 = sel[0].width;  redraw();  }    else { sel[0].rotate(-x); break }
}
/////////////////////////////////////////   CHANGE DIRECTION
w1 = sel[0].width;
w2 = 0;
x = 0;

for (i = 0; i < 40; i++)  //  w2 на старте всегда  меньше w1
{
if ( w2 < w1 )    {  w1 = sel[0].width;  x = 0.2;  sel[0].rotate(x);  w2 = sel[0].width;  redraw();  }   else { sel[0].rotate(-x); break }
}

executeMenuCommand('ungroup');
var sel = doc.selection;  //  update selection


































var doc = app.activeDocument;
var sel = doc.selection;
var mmp = 2.8346457481;

var summ = 0;
var arr = [];

executeMenuCommand("selectall");
var sel = doc.selection;  //  update selection


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   первые  3  квадратика  для  определения  мин.  квадратика
                                                                                                               //   мин квадратик - это 1 / 3 большого квадратика
//~ for ( i = 0; i < 3; i++ ) 
//~ {
//~     var xw = ( Math.round (   ( sel[i].width / mmp )   * 100   )  /  100  )   ;  //  x - это мин квадратик = 1 / 3 большого квадратика
//~     var xh = ( Math.round (   ( sel[i].height / mmp )   * 100   )  /  100  )   ; //  x - это мин квадратик = 1 / 3 большого квадратика
//~     arr.push ( xw + " x " + xh + " delta:   " + xw / xh );
//~     summ = summ + (xw + xh) / 2 / 3 / 3 ;  //  вторая тройка - т.к. деление трёх объектов на три части
//~ }

//   summ - минимальный квадратик

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

var doc = app.activeDocument;
var sel = doc.selection;
var mmp = 2.8346457481;





var arr1 = [];  //  get X
var arr2 = [];  //  get index
var arr3 = [];  //  get Y


var arr_A = [ [ ] ]; // multi array
var arr_B = [ [ ] ]; // multi array

//  21 12 22   если скрипт будет выделять 1 объект - это признак неверного поворота кода, 
//                     при правильном повороте кода скрипт определит 2-3 и более объектов (мелкий квадратик плюс внутр. ещё более мелкий квадратик)

var arr_matched_XY = [] ; //  matched x and y by equal i

executeMenuCommand("selectall");

executeMenuCommand("group");

var sel = doc.selection;

var sel_whole_width = sel [ 0 ].width / mmp ;  //  get whole width of selection to calculate matrix width / height
var whole_left = sel [ 0 ].left / mmp ;
var whole_top = doc.artboards[0].artboardRect[1] / mmp  -  sel [ 0 ].top / mmp ;    //  верный расчёт высоты через artboard вместо top

//alert ( "all width    " + sel_whole_width ) ;


executeMenuCommand("ungroup");

app.executeMenuCommand("noCompoundPath");   //   release all compound paths

executeMenuCommand("selectall");     var sel = doc.selection;

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//var top_real = doc.artboards[0].artboardRect[1] / mmp - sel [ 0 ].top / mmp ;   //   верный расчёт высоты через artboard вместо top

for ( i = 0; i < sel.length; i++ ) 
{

arr1.push ( Math.round (   ( doc.artboards[0].artboardRect[1] / mmp - sel [ i ].top / mmp )   * 100   )  /  100  )    //   верный расчёт высоты через artboard вместо top
arr2.push ( Math.round (   ( sel [ i ].left / mmp )   * 100   )  /  100  )




arr3.push ( i ) ;



arr_A.push (   [   arr1 [ i ], arr3 [ i ]   ]   ) ;
arr_B.push (   [   arr2 [ i ], arr3 [ i ]   ]   ) ;



}

arr_A.sort(sortFunction);
arr_B.sort(sortFunction);

//alert ( "A   " + arr_A.join('\n')    ) ;
//alert ( "B   " + arr_B.join('\n')    ) ;

//  если алгоритм находит не самый левый верхний квадратик, уменьшай оба значения i и k
//  может быть ввести + - 2 mm от значения ?
//  при i и k = 10 находил 1 объект в неверном углу, при 20 уже норм
for ( i = 0; i < 20 ; i++ )   //  ограничим число объектов для поиска, если будет слишком мало - ничего не найдёт, если слишком много - найдёт не те объекты
{
    for ( k = 0; k < 20; k++ )    //  ограничим число объектов для поиска, если будет слишком мало - ничего не найдёт, если слишком много - найдёт не те объекты
    {

//~ alert ( "arr_A test  " + arr_A [ i ] ) ;
//~ alert ( "arr_A test  " + arr_B [ k ] ) ;

//alert ( "i  " + i + "   k   " + k  +  "   arr A   "  +   arr_A [ i ] [ 1 ]    +   "   arr B  " +  arr_B [ k ] [ 1 ]    ) ;

        if (   arr_A [ i ] [ 1 ] != undefined && arr_A [ i ] [ 1 ] == arr_B [ k ] [ 1 ]   )   //  check  for  undefined  values
        {
        //alert ( "index found         arr A     i  " + i + "   k   " + k + "   " + arr_A [ i ] [ 0 ]  + " --- " + arr_A [ i ] [ 1 ]    +   "   arr B  " +  arr_B [ k ] [ 0 ] + " --- " + arr_B [ k ] [ 1 ]   ) ;

        //executeMenuCommand("deselectall");
        doc.selection = null;
        //doc.pageItems [ arr_A [ i ] [ 1 ] ].selected = true ;  //  pageItem  выделяет path внутри compound path !    для  paths всё отлично работает !!!

            //  15 12 22  проверим квадратность
            //alert ( "width   " + doc.pageItems [ arr_A [ i ] [ 1 ] ].width / mmp + "/nheight   " + doc.pageItems [ arr_A [ i ] [ 1 ] ].height / mmp  )
            
            var delta_wh = doc.pageItems [ arr_A [ i ] [ 1 ] ].width   /   doc.pageItems [ arr_A [ i ] [ 1 ] ].height ;  //  поделим ширину и высоту, у квадрата значение близко к 1
            
            //alert ( "delta wh   " + delta_wh ) ;
            
            //  проверим если объект квадратный
            if ( delta_wh > 0.9 && delta_wh < 1.1 )  //   поделеннная ширина и высота, у квадрата значение близко к 1
            {
                //alert ( "0.9 < delta wh < 1.1    " + delta_wh ) ;            
            }

                //  проверим если объект НЕ квадратный, повернём весь qr-код
                if ( delta_wh < 0.9 || delta_wh > 1.1 )  //   поделеннная ширина и высота, у квадрата значение близко к 1    
                {
                    //alert ( "нужно повернуть    " + delta_wh ) ; 
                    rotation_key = 1 ; //  повернём картинку на 90 градусов чтобы левый верхний угол имел большой квадрат, иначе не посчитает размер
                }
            //  END - 15 12 22  проверим квадратность



        k = arr_A.length ;  //  stop
        i = arr_A.length ;  //  stop        
        }
    }
}



///////////////////////////////////////////////////    повторим весь цикл ещё раз для занесения всех найденных левых верних объектов чтобы потом проверить их по левым верхним точкам

for ( i = 0; i < 20 ; i++ )   //  ограничим число объектов для поиска, если будет слишком мало - ничего не найдёт, если слишком много - найдёт не те объекты
{
    for ( k = 0; k < 20; k++ )    //  ограничим число объектов для поиска, если будет слишком мало - ничего не найдёт, если слишком много - найдёт не те объекты
    {
        if (   arr_A [ i ] [ 1 ] != undefined && arr_A [ i ] [ 1 ] == arr_B [ k ] [ 1 ]   )   //  check  for  undefined  values
        {
            arr_matched_XY.push ( doc.pageItems [ arr_A [ i ] [ 1 ] ] ) ; // get matched objects - все самые левые верхние объекты 
        }
    }
}

//alert ( "arr_matched_XY   " + arr_matched_XY.join('\n')    ) ;

///////////////////////////////////////////////////    отфильтруем левые верхние объекто по точкам

for ( m = 0; m < arr_matched_XY.length ; m ++ )
{

//alert ( arr_matched_XY [ m ].pathPoints[ 0 ].anchor[0] / mmp ) ;

    for ( n = 0; n < arr_matched_XY [ m ].pathPoints.length ; n ++ )
    {
        //  если в найденном объекте все левые точки левее на чем весь qr-код + 1 мм (проверочное поле 1 х 1 мм от лев верх края )                
        //alert ( "all_points   " + all_points + "\nm   " + m  + "\n" + doc.pageItems [ arr_A [ i ] [ 1 ] ].pathPoints[ m ].anchor[0] / mmp + "\nwhole left    " + whole_left ) ;
        //alert ( "all points      " + all_points ) ;
        
        //alert ( arr_matched_XY [ m ].pathPoints[ n ].anchor[0] / mmp ) ; 
        
        //alert ( "pass 0" ) ;
        
        if (   ( arr_matched_XY [ m ].pathPoints[ n ].anchor[0] / mmp )   <   whole_left + ( 1 * mmp ) )  
        {
            //alert ( "pass 1" ) ;
            //arr_matched_XY [ m ].pathPoints[ n ].remove() ;
                 
            if (    ( doc.artboards[0].artboardRect[1] / mmp - ( arr_matched_XY [ m ].pathPoints[ n ].anchor[1] / mmp )   )   <   whole_top + ( 1 * mmp )    )
            {
                //alert ( "ok" ) ;
                //arr_matched_XY [ m ].pathPoints[ n ].remove() ;
                arr_matched_XY [ m ].selected = true ;
                //  если находит > 1 объекта это значит что нашёлся один из 3х нужных квадратов, если нашёлся 1 объект - точно не тот угол
            }
        }
    }

}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      ПРОВЕРИМ ЕЩЁ РАЗ ЛЕВ ВЕРХ ОБЪЕКТ
//  если выделен 1 объект - значит нужно повернуть qr-код, правильно когда найдено >1 объекта, т.к. 3 квадратика имеют ещё и внутр. квадратики
redraw () ;

if ( check_key = 1 )
{
//alert ( "check key" ) ;
}

var sel = doc.selection;

if ( sel.length < 2 )
{
//alert ( "sel < 1, необходимо повернуть qr-код" ) ;

rotation_key = 1 ;  //  ключ для поворота qr-кода
}

var delta_wh_2 = 0 ;  //  поделим ширину и высоту, у квадрата значение близко к 1

if ( sel.length > 1 )
{
    for ( i = 0; i < sel.length; i++ ) 
    {
    delta_wh_2 = sel [ i ].width   /   sel [ i ].height ;  //  поделим ширину и высоту, у квадрата значение близко к 1
    
        if ( delta_wh_2 < 0.9 || delta_wh_2 > 1.1 )  //   проверка на квадратичность, всё что НЕ квадратное, то...
        {
            //alert ( "проверка на квадратичность  0.9 < delta wh < 1.1    " + delta_wh_2 ) ;
            rotation_key = 1 ;  //  ключ для поворота qr-кода
        }
    }
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      

executeMenuCommand("group"); //  временно групируем для вычисления размера выделенных квадратиков

var sel = doc.selection;

var matched_squares = sel [ 0 ].width / mmp ; 

executeMenuCommand("ungroup");  //  ungroup back

//alert ( "in the end width of 1st sel   " + sel [ 0 ].width / mmp ) ;

//alert ( "matched_squares   " + matched_squares ) ;   //  размер найденных квадратиков включая внутренние

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      РАСЧЕТ 1 КВАДРАТИКА
var small_square = sel [ 0 ].width / 7 / mmp ;  //  большой квадрат состоит из 7 маленьких базовых квадратиков, получаем минимальный квадратик

//alert ( "matrix   " + Math.round ( sel_whole_width / small_square * 10 ) / 10 ) ;

matrix_from_corner = Math.round ( sel_whole_width / small_square * 10 ) / 10 ;


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      COMBINE BACK
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
executeMenuCommand("selectall");
app.executeMenuCommand("compoundPath");   //   combine back all compound paths

////////////////////////////////////////////////////////////////////////  SORT X
function sortFunction(a, b) 
{
    if (a[0] == b[0]) { return 0; }
    else { return (a[0] < b[0]) ? -1 : 1; }
}
////////////////////////////////////////////////////////////////////////  SORT Y
function sortFunctionY(a, b) 
{
    if ( a[0] == b[0] && a[1] < b[1] )  //  проверяем - если x1 = x2 и Y1 < Y2 - здесь проверка сразу двух столбиков - первого и второго ! в этом ключ сортировки !
    { return  1; }
    else { return -1 }; //  -1 вызывало сбой сортировки - один индекс был пустым
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

executeMenuCommand("selectall");

executeMenuCommand("group");

var sel = doc.selection;  //  update selection

var sample_big = ( sel[0].width / mmp + sel[0].height / mmp )  /  2  ;  //   ширина + высота  /  2  =  среднее значение стороны квадрата

var sample_top = sel[0].top / mmp;  //  top всей группы
var sample_left = sel[0].left / mmp;   //  left  всей группы

executeMenuCommand("ungroup");

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

var mygray = new GrayColor();
mygray.gray = 0;

}  ////////////////   END  -  unction step_1 ()

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      CHECK ROTATION and ROTATE IF NECESSARY
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////






//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      ДЕЛАЕМ КВАДРАТНЫМ И ЦЕНТРУЕМ
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

executeMenuCommand("selectall");    var sel = doc.selection;

var ww = sel[0].width / mmp ;
var hh = sel[0].height / mmp ;

//alert ( ww + " " + hh) ;

var width_center = sel[0].left + ( sel[0].width / 2 ) ;  //  get center x
var height_center = sel[0].top - ( sel[0].height / 2 ) ;  //  get center y

//  если ширина больше высоты, ужимаем до высоты и наоборот, почему то чуть-чуть сжимает оба значения, хотя должен одно
if ( ww > hh ) { sel[0].width = sel[0].height } else { sel[0].height = sel[0].width }

sel[0].left = width_center - sel[0].width / 2 ;    //  центруем сжатый qr-код, возможны погрешности примерно в 0,3 мм
sel[0].top = height_center + sel[0].height / 2 ;

redraw();

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      CHECK ROTATION - END

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      ПРОВЕРКА РАЗМЕРА
var matrix_from_corner_rounding = Math.round ( matrix_from_corner );

if ( matrix_from_corner_rounding >= 21 && matrix_from_corner_rounding <= 177 )  //  проверяем диапазон размеров qr-кода
{
    //  кратность 4м, проверка ввёденного значения qr-кода на соответствие стандарту
    if ( ( matrix_from_corner_rounding - 21 ) % 4 == 0 )  
    {  
        //alert ("стандарт ок - значит по формуле x - 21 кратно 4 проходит   " + matrix_from_corner_rounding ) 
    } 
                                                                                                                  // по формулке  x - 21 = y кратный 4м >= 21 и <= 177
                                                                                                                  
    //else { alert ( "число не ложится в размер "  + matrix_from_corner_rounding ) }
    else { 
        //          число не ложится в стандартный размер qr-кодов, округлим его до четвёрок
        //alert ( "отклонение в расчёте размера, подберите ближайшее число из таблицы" ) 
        
        function roundNearest4 ( num )   {  return Math.round ( num / 4 ) * 4 ;  }   //  функция округления до 4х
        matrix_from_corner_rounding  =  roundNearest4 ( matrix_from_corner_rounding - 21 ) + 21 ;
        }

    //alert ( "matrix   " + matrix ) ;
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      WINDOW
var myWindow = new Window ("dialog", "QR Code Magic");

var myInputGroup_2 = myWindow.add ("group");

var xxx = "Ваш qr-код похоже имеет размер: \n" + matrix_from_corner + " x " + matrix_from_corner + "\nно это не точно... \n\nесли рассчитанный размер меньше 21, необходимо  увеличить картинку с кодом" +
"\n\nразмеры QR-кодов по стандарту:" +
"\n21 x 21   \n25 x 25   \n29 x 29   \n33 x 33   \n37 x 37   \n41 x 41   \n45 x 45  \n49 x 49   \n53 x 53   \n57 x 57   \n61 x 61   \n65 x 65" + 
"\n69 x 69   \n73 x 73   \n77 x 77   \n81 x 81   \n85 x 85   \n89 x 89   \n93 x 93   \n97 x 97   \n101 x 101 \n... \n177 x 177" +  "\n\nвведите размер одним числом:" ;


myInputGroup_2.add ("statictext", undefined, xxx, {multiline: true} );

var myInputGroup = myWindow.add ("group");

myInputGroup.add ("statictext", undefined, );

var myText = myInputGroup.add ("edittext", undefined, matrix_from_corner_rounding ); //  matrix_from_corner_rounding - округлённый размер qr-кода подставляем в поле ввода для удобства

myText.characters = 20;
myText.active = true;

var myButtonGroup = myWindow.add ("group");
myButtonGroup.alignment = "right";
myButtonGroup.add ("button", undefined, "OK");
myButtonGroup.add ("button", undefined, "Cancel");
myWindow.show ();

//alert ( myText.text ) ;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      WINDOW   -   END


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      START MAKING SQAURES

var matrix = myText.text;

executeMenuCommand("selectall");

executeMenuCommand("group");

var sel = doc.selection;  //  update selection

var sample_big = sel[0].width / mmp;

//var sample = sel[0].width / mmp;  //  draw a rectangle to define 1 x 1 sample square
var sample_top = sel[0].top / mmp;
var sample_left = sel[0].left / mmp;
var sample_width_center = sel[0].left / mmp + ( sel[0].width / 2 / mmp ) ;  //  get center x for matrix
var sample_height_center = sel[0].top / mmp - ( sel[0].height / 2 / mmp ) ;  //  get center y for matrix - here is negative value

executeMenuCommand("ungroup");

var mygray = new GrayColor();
mygray.gray = 0;

//  создаём маленький квадратик
var rect  = doc.activeLayer.pathItems.rectangle( sample_top * mmp, sample_left * mmp, sample_big / matrix * mmp / 10, sample_big / matrix * mmp / 10 );  //  scale squares to 10%

//var rect  = doc.activeLayer.pathItems.rectangle( sample_top * mmp - sample_big / matrix * mmp / 4, sample_left * mmp + sample_big / matrix * mmp / 4, sample_big / matrix * mmp / 3, sample_big / matrix * mmp / 3);

rect.filled = true;
rect.fillColor = mygray;

var igroup = doc.activeLayer.groupItems.add();

var newPath = rect.move ( igroup, ElementPlacement.PLACEATBEGINNING );  //  move first square to the group

    for ( i = 0; i < matrix - 1; i++ )   //  25 x 25 qr-code squares size or else
    {

    var newPath = rect.duplicate ( igroup, ElementPlacement.PLACEATBEGINNING );

    newPath.translate ( sample_big / matrix * mmp + ( i * sample_big / matrix * mmp ), 0);  //  move every new square to the right
    //doc.pathItems[1].remove();
    }

        for ( k = 0; k < matrix - 1; k++ )   //  25 x 25 qr-code squares size - vertical
        {
            igroup.duplicate ( doc.activeLayer, ElementPlacement.PLACEATBEGINNING );
            igroup.translate ( 0, -1 * sample_big / matrix * mmp );
        }

executeMenuCommand("hide");

executeMenuCommand("selectall");

executeMenuCommand("group");   //   НАЧАЛО ЦЕНТРОВКИ ТОЧЕК

executeMenuCommand("selectall");
var sel = doc.selection;  //  update selection

//sel[0].left / mmp + sel[0].width / 2 / mmp ;  //  get center x for matrix
//var sample_height_center = sel[0].top / mmp - sel[0].height / 2 / mmp ;  //  get center y for matrix - here is negative value

//alert ( sample_width_center ) ;

//alert ("center");

sel[0].left = sample_width_center * mmp - sel[0].width / 2 ;    //   ЦЕНТРУЕМ
sel[0].top = sample_height_center * mmp + sel[0].height / 2 ;

redraw ();

//executeMenuCommand("group");

//alert ( "center x  " + sample_width_center + "\ncenter y  " + sample_height_center ) ;

executeMenuCommand("showAll");

//  зачем скрывал растр???
//~ for (i = 0; i < doc.pageItems.length; i++)
//~ {
//~     if ( doc.pageItems[i].typename == "RasterItem")
//~     {
//~     alert (i);
//~     doc.pageItems [ i ].hidden = true ;  //  turn off picture
//~     }
//~ }

//executeMenuCommand("Inverse menu item");  //  inverse selection

executeMenuCommand("hide");

doc.pageItems[0].selected = true ;  //  select top group

executeMenuCommand("ungroup");  //  ungroup top objects

//doc.pageItems[  pageItems.length ].hidden = false ;  //  select top group






















var doc = app.activeDocument;
var sel = doc.selection;
var mmp = 2.8346457481;

//  после размножения квадратиков,  вычитаем вектора - Path finder  и завершаем скрипт

//  select white squares
//executeMenuCommand("selectall");
var sel = doc.selection;  //  update selection

//~ for ( i = 0; i < sel.length; i++ ) 
//~ {
//~     sel[i].width = sel[i].width * 10;
//~     sel[i].height = sel[i].height * 10;
//~     sel[i].left = sel[i].left - sel[i].width / 4;
//~     sel[i].top = sel[i].top + sel[i].height / 4;
//~ }

executeMenuCommand("hide");

executeMenuCommand("selectall");

executeMenuCommand("ungroup");
executeMenuCommand("ungroup");
executeMenuCommand("ungroup");

executeMenuCommand("compoundPath");

executeMenuCommand("showAll");

executeMenuCommand("selectall");

executeMenuCommand("group");

//executeMenuCommand("Live Pathfinder Soft Mix");
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////  Live Effect
var sel = doc.selection;  //  update selection

var xmlstring = '<LiveEffect index="0" isPre="1" major="1" minor="0" name="Adobe Pathfinder"><Dict data="I Command 11 R Mix 0.5 R TrapTint 0.4 R TrapMaxTint 1 B TrapReverse 0 R TrapAspect 1 R Precision 10 B RemovePoints 0 R TrapThickness 0.25 B ConvertCustom 1 R TrapTintTolerance 0.05 B ExtractUnpainted 1 B TrapConvertCustom 0"/></LiveEffect>' ;

for ( i = 0; i < sel.length; i++ )
{
    sel [ i ] .applyEffect ( xmlstring ) ;
}

//alert ( "1      " + sel.length ) ;

executeMenuCommand("selectall");  //  нужно для Live Effect

executeMenuCommand("expandStyle");

executeMenuCommand("ungroup");
executeMenuCommand("ungroup");
executeMenuCommand("ungroup");

executeMenuCommand("selectall");
var sel = doc.selection;  //  update selection

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   удаляем белые и чёрные элементы, оставим серые квадратики в пол размера
for ( i = 0; i < sel.length; i++ ) 
{
    if (sel[i].filled == true && sel[i].fillColor.typename == "GrayColor")
    {
        //alert (sel[i].fillColor.gray);

        if ( sel[i].fillColor.gray == 0 )  //  find white objects to remove
        { 
        doc.selection = null;
        //alert ("123");
        sel[i].selected = true;
        i = sel.length;  //  stop  cycles
        executeMenuCommand('Find Fill Color menu item');
        }
    }
}

executeMenuCommand('clear');  //  remove white objects
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

executeMenuCommand("selectall");
var sel = doc.selection;  //  update selection

for ( i = 0; i < sel.length; i++ ) 
{
    if (sel[i].filled == true && sel[i].fillColor.typename == "GrayColor")
    {
        //alert (sel[i].fillColor.gray);

        if ( sel[i].fillColor.gray < 90 )  //  find white objects to remove
        { 
        doc.selection = null;
        //alert ("123");
        sel[i].selected = true;
        i = sel.length;  //  stop  cycles
        executeMenuCommand('Find Fill Color menu item');
        }
    }
}

executeMenuCommand("Inverse menu item");  //  inverse selection

executeMenuCommand('clear');  //  remove white objects
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

executeMenuCommand("selectall");
var sel = doc.selection;  //  update selection

var mydark = new GrayColor();
mydark.gray = 50;   //  final qr-code color

for ( i = 0; i < sel.length; i++ ) 
{
    //if ( sel [ i ].width * 10 * 1.1 < sample_big / matrix )
    //  замечено, что все кривые квдратики ужимаются только по высоте, так что проверка дальше только по height, вертикальные кривые квадртаики были изза переворотов кода
    if ( sel [ i ].height / mmp * 10 * 1.1 < sample_big / matrix )  //  каждый кривой квадратик увеличим на 10% ( * 1.1 ) и посмотрим не < ли он эталонного, если меньше, то удалим
    {
    //alert ( "sel width * 10:   " + sel [ i ].height / mmp * 10 + "\n\nsample big / matrix:   " + sample_big / matrix );  //  размер квадратика на выходе
    sel [ i ].remove() ;  //  удаляем артефакты - не квадртаные квадраты - глюки векторизации при низком разрешении
    //redraw() ;
    }
    else {
    sel[i].width = sel[i].width * 10;
    sel[i].height = sel[i].height * 10;
    sel[i].left = sel[i].left - sel[i].width / 4;
    sel[i].top = sel[i].top + sel[i].height / 4;
    sel[i].fillColor = mydark;
            }
}

//alert ( sample_big / matrix );  //  размер квадратика на выходе

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    ПОЧИСТИМ МУСОР - НЕ КВАДРАТНЫЕ ЭЛЕМЕНТЫ ОТ КАРТИНОК НИЗКОГО РАЗРЕШЕНИЯ

executeMenuCommand("selectall");

executeMenuCommand("compoundPath");

executeMenuCommand("selectall");    var sel = doc.selection;  //  update selection

//alert ( " sample_width_center   " + sample_width_center / mmp + "\n\n sample_height_center   " + sample_height_center / mmp );  //  выравнивание по центру с картинкой

//alert ("center 2");

sel[0].left = sample_width_center * mmp - sel[0].width / 2 ;
sel[0].top = sample_height_center * mmp + sel[0].height / 2 ;

redraw ();

//~ sel[0].left = sample_width_center -  sel[0].width / 2  ;  
//~ sel[0].top = sample_height_center - sel[0].height  ;

executeMenuCommand("unlockAll");  //  unlock original picture

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      GET BACK ORIGINAL ROTATION
if ( rotsn > 0) 
{ 
    executeMenuCommand("selectall");
    executeMenuCommand('group');
    executeMenuCommand("selectall");    var sel = doc.selection;  //  update selection
    sel [ 0 ].rotate ( -90 ) ;
    executeMenuCommand('ungroup');
}

redraw ();

executeMenuCommand("deselectall");



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      RELEASE EVERYTHING
//var objs = app.activeDocument.pageItems;
// or if you want only selection use app.activeDocument.selection

//traverseSceneObjects(objs);

function traverseSceneObjects(pageItems)
{
    for (var  i =0 ;  i <pageItems.length;  i ++ )
    {
        var item = pageItems[ i ];
        var typename = item.typename;

        // apply action or get the subitems of object
        if (typename === "PathItem")
        {
            item.clipping = false;

        } else if (typename === "GroupItem") 
        {
            traverseSceneObjects( item.pageItems );
            release( item, "pageItems" ); 

        } else if (typename === "CompoundPathItem" ) 
        {
            traverseSceneObjects( item.pathItems );
            release( item, "pathItems" );
        }
    }
}

function release(obj, action) 
{
    for ( i=obj [ action ].length - 1 ; i >= 0; i -- )
    {
        obj [action] [ i ].move ( obj, ElementPlacement.PLACEAFTER );
    }
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      delete_not_img

function delete_not_img() 
{
for ( i = 0; i < doc.pageItems.length; i++ )
{
    if ( doc.pageItems [ i ].typename != "RasterItem" )
        if ( doc.pageItems [ i ].typename != "PlacedItem" )
        {
            {
        //alert ( "pageitems   " + doc.pageItems[i].typename +   "   i    " + i ) ;
        doc.pageItems [ i ].remove() ;
        redraw () ;
        //alert ( "pageitems   " + doc.pageItems.length +   "   i    " + i ) ;
            }
        }

//  приделаем костыль, почемуто не удаляет все объекты до одного...

//alert ( "page itmes:   " + doc.pageItems.length ) ;

//if ( doc.pageItems.length > 1 && i == doc.pageItems.length - 1 ) { i = i - 1 } //  запускаем цикл ещё раз пока не останется только один объект с qr-кодом

}
} // end function

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      GLOBAL START POINT - END
}   //  if ( start == 1 ) //  start script